Crash when navigating HTTPS uri through proxy

Bug #896824 reported by Pesmontis on 2011-11-27
14
This bug affects 2 people
Affects Status Importance Assigned to Milestone
libsoup
Fix Released
High
libsoup2.4 (Ubuntu)
High
Unassigned
Oneiric
High
Unassigned

Bug Description

After having installed Privoxy, I opened 'Preferences' in Midori to set the proxy address in the 'Network' tab.
eg. 192.168.0.1:8118

Now whenever I navigate an HTTPS uri, Midori crashes.
This happens for instance with the Duck Duck Go HTTPS search page.

Running on Ubuntu Oneiric Ocelot, Midori v0.4.0, libwebkitgtk v3.0-0, privoxy v3.0.17-1

Jiří Janoušek (fenryxo) wrote :
Download full text (3.5 KiB)

I think this is a bug in libsoup2.4-1 2.36.0-0ubuntu1. It may be fixed in libsoup 2.36.1, see https://bugzilla.gnome.org/show_bug.cgi?id=661758

GNU Debugger session:

$ gdb --args midori https://plus.google.com
GNU gdb (Ubuntu/Linaro 7.3-0ubuntu2) 7.3-2011.08
Copyright (C) 2011 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law. Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-linux-gnu".
For bug reporting instructions, please see:
<http://bugs.launchpad.net/gdb-linaro/>...
Reading symbols from /usr/bin/midori...Reading symbols from /usr/lib/debug/usr/bin/midori...done.
done.
(gdb) run
Starting program: /usr/bin/midori https://plus.google.com
[Thread debugging using libthread_db enabled]
[New Thread 0x7fffe84a5700 (LWP 23270)]
[New Thread 0x7fffa7ca2700 (LWP 23271)]
[New Thread 0x7fff9b8f8700 (LWP 23272)]
[New Thread 0x7fff99db4700 (LWP 23273)]
[New Thread 0x7fff98444700 (LWP 23274)]
[New Thread 0x7fff95fe1700 (LWP 23275)]
[New Thread 0x7fff957e0700 (LWP 23276)]
[New Thread 0x7fff94fdf700 (LWP 23277)]
[New Thread 0x7fff947de700 (LWP 23278)]
[New Thread 0x7fff93fdd700 (LWP 23279)]

(midori:23267): GLib-GObject-CRITICAL **: g_object_ref: assertion `G_IS_OBJECT (object)' failed

(midori:23267): GLib-GObject-WARNING **: invalid (NULL) pointer instance

(midori:23267): GLib-GObject-CRITICAL **: g_signal_connect_data: assertion `G_TYPE_CHECK_INSTANCE (instance)' failed

(midori:23267): GLib-GObject-WARNING **: invalid (NULL) pointer instance

(midori:23267): GLib-GObject-CRITICAL **: g_signal_connect_data: assertion `G_TYPE_CHECK_INSTANCE (instance)' failed

(midori:23267): GLib-GObject-CRITICAL **: g_type_instance_get_private: assertion `instance != NULL && instance->g_class != NULL' failed

Program received signal SIGSEGV, Segmentation fault.
soup_socket_is_ssl (sock=0x0) at soup-socket.c:1079
1079 soup-socket.c: No such file or directory.
 in soup-socket.c
(gdb) bt
#0 soup_socket_is_ssl (sock=0x0) at soup-socket.c:1079
#1 0x00007ffff59e3e60 in new_iostate (msg=0x7ffff87510e0, sock=0x0, mode=SOUP_MESSAGE_IO_CLIENT,
    get_headers_cb=0x7ffff59e20d0 <get_request_headers>, parse_headers_cb=<optimized out>,
    header_data=<optimized out>, completion_cb=0x7ffff59f0c50 <message_completed>,
    completion_data=0x7ffff870adf0) at soup-message-io.c:1082
#2 0x00007ffff59e5737 in soup_message_io_client (item=0x7ffff870adf0,
    get_headers_cb=0x7ffff59e20d0 <get_request_headers>,
    parse_headers_cb=0x7ffff59e1ef0 <parse_response_headers>, header_data=0x7ffff870adf0,
    completion_cb=0x7ffff59f0c50 <message_completed>, completion_data=<optimized out>)
    at soup-message-io.c:1120
#3 0x00007ffff59f06fb in process_queue_item (item=0x7ffff870adf0, should_prune=0x7fffffffd9cc, loop=1)
    at soup-session-async.c:390
#4 0x00007ffff59f09eb in run_queue (sa=<optimized out>) at soup-session-async.c:442
#5 0x00007ffff59f1113 in idle_run_queue (sa=0x7ffff82b3010) at soup-session-async.c:465
#6 0x00007ffff7644a5d in g_main_context_disp...

Read more...

Changed in libsoup:
importance: Unknown → High
status: Unknown → Fix Released
Download full text (5.2 KiB)

Hey Jiri,

I downloaded libsoup 2.36.1 from SoftPedia, but I don't have a clue how to build / install it.

I did something else which seems to work:
- I installed webkitgtk 3.0 oowtk from the webkit-team ppa;
- I installed midori_0.4.2-1~oowkt1_i386.deb (downloaded from the launchpad website).

Although I installed a different webkitgtk version, the version of libsoup is unchanged (!).
I tested with the HTTPS websites of Duck Duck Go, Hotmail, and Facebook.

Cheers,
Pesmontis

> Date: Mon, 28 Nov 2011 11:06:39 +0000
> From: <email address hidden>
> To: <email address hidden>
> Subject: [Bug 896824] Re: Crash when navigating HTTPS uri through proxy
>
> I think this is a bug in libsoup2.4-1 2.36.0-0ubuntu1. It may be fixed
> in libsoup 2.36.1, see https://bugzilla.gnome.org/show_bug.cgi?id=661758
>
> GNU Debugger session:
>
> $ gdb --args midori https://plus.google.com
> GNU gdb (Ubuntu/Linaro 7.3-0ubuntu2) 7.3-2011.08
> Copyright (C) 2011 Free Software Foundation, Inc.
> License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
> This is free software: you are free to change and redistribute it.
> There is NO WARRANTY, to the extent permitted by law. Type "show copying"
> and "show warranty" for details.
> This GDB was configured as "x86_64-linux-gnu".
> For bug reporting instructions, please see:
> <http://bugs.launchpad.net/gdb-linaro/>...
> Reading symbols from /usr/bin/midori...Reading symbols from /usr/lib/debug/usr/bin/midori...done.
> done.
> (gdb) run
> Starting program: /usr/bin/midori https://plus.google.com
> [Thread debugging using libthread_db enabled]
> [New Thread 0x7fffe84a5700 (LWP 23270)]
> [New Thread 0x7fffa7ca2700 (LWP 23271)]
> [New Thread 0x7fff9b8f8700 (LWP 23272)]
> [New Thread 0x7fff99db4700 (LWP 23273)]
> [New Thread 0x7fff98444700 (LWP 23274)]
> [New Thread 0x7fff95fe1700 (LWP 23275)]
> [New Thread 0x7fff957e0700 (LWP 23276)]
> [New Thread 0x7fff94fdf700 (LWP 23277)]
> [New Thread 0x7fff947de700 (LWP 23278)]
> [New Thread 0x7fff93fdd700 (LWP 23279)]
>
> (midori:23267): GLib-GObject-CRITICAL **: g_object_ref: assertion
> `G_IS_OBJECT (object)' failed
>
> (midori:23267): GLib-GObject-WARNING **: invalid (NULL) pointer instance
>
> (midori:23267): GLib-GObject-CRITICAL **: g_signal_connect_data:
> assertion `G_TYPE_CHECK_INSTANCE (instance)' failed
>
> (midori:23267): GLib-GObject-WARNING **: invalid (NULL) pointer instance
>
> (midori:23267): GLib-GObject-CRITICAL **: g_signal_connect_data:
> assertion `G_TYPE_CHECK_INSTANCE (instance)' failed
>
> (midori:23267): GLib-GObject-CRITICAL **: g_type_instance_get_private:
> assertion `instance != NULL && instance->g_class != NULL' failed
>
> Program received signal SIGSEGV, Segmentation fault.
> soup_socket_is_ssl (sock=0x0) at soup-socket.c:1079
> 1079 soup-socket.c: No such file or directory.
> in soup-socket.c
> (gdb) bt
> #0 soup_socket_is_ssl (sock=0x0) at soup-socket.c:1079
> #1 0x00007ffff59e3e60 in new_iostate (msg=0x7ffff87510e0, sock=0x0, mode=SOUP_MESSAGE_IO_CLIENT,
> get_headers_cb=0x7ffff59e20d0 <get_request_headers>, parse_headers_cb=<optimized out>,
> header_data=<optimized out>, completion_cb=0x7ffff59f0c50 <mes...

Read more...

Jiří Janoušek (fenryxo) wrote :

> Although I installed a different webkitgtk version, the version of libsoup is unchanged

libsoup is not a part of webkitgtk, it's a separate library

Pesmontis (pesmontis) wrote :

It's good that I wrote 'seems' to work, because it doesn't.
In midori_0.4.2-1~oowkt1 I didn't set a proper proxy port number
(left it at 8080, while the proxy addres was set as 192.168.0.1:8118)..

Pesmontis (pesmontis) wrote :

Alright, with libsoup 2.36.1 it works.
I used this page to build & install libsoup:
http://www.linuxfromscratch.org/blfs/view/svn/basicnet/libsoup.html

Shaw Terwilliger (sterwill) wrote :

I have a similar problem with 2.36.0-0ubuntu1, which also happens with the vanilla upstream 2.36.0 (built from source), though my crash is in soup_socket_is_ssl. I can't repro my crash using 2.36.1 built from source on Oneiric, or with 2.36.1-1ubuntu1 on Precise (as of 2011-01-12).

My crash happens when Eclipse hosts WebKit GTK, after being redirected to an SSL web site with HTTP and HTTPS proxies enabled the entire time. Takes down the entire JVM (see the attached JVM crash report). I'm associating my problem with this thread because there were just a few upstream changes between 2.36.0 and 2.36.1, and I think we're just seeing different symptoms of the same problem.

2.36.1 seems to fix this issue completely for me, and it would be nice to see an update to Oneiric.

Sebastien Bacher (seb128) wrote :

There are only 3 fixes between 2.36.0 and 2.36.1, not sure which one fixes it since the bugs referenced to the one fix look different from this one...

Changed in libsoup2.4 (Ubuntu):
status: New → Fix Released
importance: Undecided → High
Changed in libsoup2.4 (Ubuntu Oneiric):
importance: Undecided → High
status: New → Triaged
Cody Garver (codygarver) on 2013-04-21
Changed in midori:
status: New → Incomplete
Rolf Leggewie (r0lf) wrote :

oneiric has seen the end of its life and is no longer receiving any updates. Marking the oneiric task for this ticket as "Won't Fix".

Changed in libsoup2.4 (Ubuntu Oneiric):
status: Triaged → Won't Fix
Daniel Fore (danrabbit) on 2015-03-25
no longer affects: midori
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.